using ADerrors
#PDG
const hc = 197.3269804 #MeV fm
const M_values = [1869.65, 2010.26, 1968.34, 2112.2, 2980.3, 3096.916, 5279.65, 5366.3] #MD, MD*, MDs, MDs*, \eta_c, J/\psi , MB, MBs(MeV)
const M_error = [0.05, 0.05, 0.07, 0.4, 1.2, 0.011, 0.12, 0.6]
#1802.05243 
const b_values = [3.40, 3.46, 3.55, 3.70, 3.85]
const ZM_data = [1.9684, 1.9935, 2.0253, 2.0630, 2.0814]
const ZM_error = [35, 27, 33, 38, 45] .* 1e-4
const ZM_tm_data = [2.6047, 2.6181, 2.6312, 2.6339, 2.6127]
const ZM_tm_error = [42, 33, 42, 48, 55] .* 1e-4
#1808.09236
const ZA_data = [0.75642, 0.76169, 0.76979, 0.78378, 0.79667]
const ZA_err = [72, 93, 43, 47, 47] .*1e-5
const ZV_data = [0.72259, 0.72845, 0.73886, 0.75574, 0.77074]
const ZV_err = [74, 89, 46, 48, 49] .* 1e-5
#2005.01352
const ZS_over_ZP_data = [1.3497, 1.2914, 1.2317, 1.1709, 1.1343]
const ZS_over_ZP_err = [83, 64, 48, 23, 25 ] .* 1e-4
#2101.02694
# const b_values2 = [3.40, 3.46, 3.55, 3.70]
const t0_data = [2.846, 3.634, 5.140, 8.564, 14.064]
const t0_error = [8, 13, 21, 24, 63] .* 1e-3
# from AS analysis 
const t0_ph_value = [0.4118]
const t0_ph_error = ones(1,1) .* 25e-4
#2101.10969
const RM_data = [2.335, 1.869, 1.523, 1.267, 1.149]
const RM_err  = [31, 19, 14, 16, 18] .* 1e-3
#1906.03445 LCP1 for heavy quarks 
const BA_MINUS_BP_data = [-0.324, -0.265, -0.196, -0.119, -0.073]
const BA_MINUS_BP_err  = [17, 14, 14, 14, 12] .*1e-3 
const ZDATA = [0.8981, 0.9468, 1.0015, 1.0612, 1.0971]
const ZERR  = [35, 35, 30, 17, 18 ] .* 1e-4

#1802.05243 taking into account correlations in zm_tm
C = [[0.375369e-6, 0.429197e-6, -0.186896e-5] [0.429197e-6, 0.268393e-4, 0.686776e-4] [-0.186896e-5, 0.686776e-4, 0.212386e-3]]
z = cobs([0.348629, 0.020921, 0.070613], C, "z")
ZP(b) = z[1] + z[2] * (b - 3.79) + z[3] * (b - 3.79)^2
Mrat = uwreal([.9148, 0.0088], "M/mhad")
zm_tm_covar(b) = Mrat / ZP(b)
# same for zm wilson
CC = [[0.164635e-4, 0.215658e-4, -0.754203e-4] [0.215658e-4, 0.121072e-2, 0.308890e-2] [-0.754203e-4, 0.308890e-2, 0.953843e-2]]
zz = cobs([2.270073, 0.121644, -0.464575], CC, "zm")
z_covar(b) = value(Mrat) * (zz[1] + zz[2]*(b-3.79) + zz[3]*(b-3.79)^2)

## taking into account correlations in r_m
#Crm = [[3.699760, -2.198586, -1.476913e-3] [-2.198586, 1.306512, 8.776569e-4] [-1.476913e-3, 8.776569e-4, 5.895710e-7] ]
#c_i = cobs([-7.86078, 5.49175, -0.54078], Crm, "c_i in rm")
#rm(b::Float64) = 1.0 +  0.004630*(6/b)^4 * ((1. +c_i[1]*(6/b)^2 + c_i[2]*(6/b)^4) / (1. + c_i[3]*(6/b)^2))

##
#Cov matrices
const C1 = zeros(5, 5)
const C2 = zeros(5, 5)
const C3 = zeros(5, 5)
const C4 = zeros(8, 8)
const C5 = zeros(5, 5)
const C6 = zeros(5, 5)
const C7 = zeros(5, 5)
const C8 = zeros(5, 5)
const C9 = zeros(5, 5)
const C10 = zeros(5, 5)

for i = 1:8
    C4[i, i] = M_error[i] ^ 2
    if i<=5
        C1[i, i] = ZM_error[i] ^ 2
        C2[i, i] = ZM_tm_error[i] ^ 2
        C5[i, i] = ZA_err[i] ^ 2
        C6[i, i] = ZS_over_ZP_err[i] ^ 2
        C7[i, i] = ZV_err[i] ^ 2       
        C8[i, i] = RM_err[i] ^2 
        C9[i,i]  = BA_MINUS_BP_err[i] ^2
        C10[i,i]  = ZERR[i] ^2
        C3[i, i] = t0_error[i] ^ 2
    end

end
const ZM = cobs(ZM_data, C1, "ZM values")
const ZM_tm = cobs(ZM_tm_data, C2, "ZM_tm values")
const t0_ = cobs(t0_data, C3, "t0")
const t0_ph = cobs(t0_ph_value, t0_ph_error .^ 2, "sqrt(8 t0) (fm)")
const a_ = t0_ph ./ sqrt.(8 .* t0_)
const M = cobs(M_values, C4, "charmed meson masses")
const Za = cobs(ZA_data, C5, "ZA")
const Zv = cobs(ZV_data, C7, "ZV")
const ZS_over_ZP = cobs(ZS_over_ZP_data, C6, "ZS/ZP")
const RM = cobs(RM_data, C8, "rm")
const BA_BP = cobs(BA_MINUS_BP_data, C9, "ba-bp")
const ZZ = cobs(ZDATA, C10, "Z")

zm(beta::Float64)         = ZM[b_values .== beta][1]
zm_tm(beta::Float64)      = ZM_tm[b_values .== beta][1]
t0(beta::Float64)         = t0_[b_values .== beta][1]
a(beta::Float64)          = a_[b_values .== beta][1]
za(beta::Float64)         = Za[b_values .== beta][1]
zv(beta::Float64)         = Zv[b_values .== beta][1]
zs_over_zp(beta::Float64) = ZS_over_ZP[b_values .== beta][1]
rm(beta::Float64)         = RM[b_values .== beta][1]
ba_bp(beta::Float64)      = BA_BP[b_values .== beta][1]
Z(beta::Float64)          = ZZ[b_values .== beta][1]


@doc raw""" 
  ca(beta:Float64; verbose::Bool = true, acceptance:Float64=10^-2)

it compute the ca coefficient of the axial vector current improvement
As of now, check whether g_0^2 < 1.8+acceptance and if true give ca according to arXiv:1502.04999
otherwise it gives 0
The default value of acceptance has no real justification at the moment
If verbose = true, it prints a warning if the g_0^2 is > 1.8  

"""

function ca(beta::Float64; verbose::Bool = true, acceptance::Float64 = 10^-2)
  g02 = 6/beta; 
  if (1.8-g02)>-acceptance # for g_0^2 about 1.8 and below it work. I decided on a 10^-2 acceptance range
    p0 = 9.2056
    p1 = -13.9847
    e= exp(p0+p1/g02)
    return -0.006033*g02*(1+e)
  end
  if verbose
    @warn raw"""
    no valid expression for g_0^2>1.8
    your g_0^2 = $(g02)
    return value set to 0. 
    If you want to use this formula, then modify the acceptance value by calling
    ```@example
    ca(beta, acceptance=<your value>) 
    ``` 
    """
  end
  return 0.0
end

